#include "stdafx.h"
#include "ShareMem.h"
#include <stddef.h>


void *InnerOpenSharedMemory( SHARED_CONTEXT *context, TCHAR *ident, DWORD desiredAccess )
{
	context->handle = OpenFileMapping(
			desiredAccess,
			FALSE,
			ident );

	if ( context->handle ) {
		context->pointer = (SHARED_STRUCT*)MapViewOfFile( context->handle, desiredAccess, 0, 0, 0 );
		if ( context->pointer ) {
			return GetSharedAddress( context->pointer );
		}
	}

	CloseHandle( context->handle );
	context->handle = NULL;
	context->pointer = NULL;

	return NULL;
}

void *OpenSharedMemory( SHARED_CONTEXT *context, TCHAR *ident )
{
	return InnerOpenSharedMemory( context, ident, FILE_MAP_READ );
}

void *OccupySharedMemory( SHARED_CONTEXT *context, TCHAR *ident )
{
	return InnerOpenSharedMemory( context, ident, FILE_MAP_READ | FILE_MAP_WRITE );
}

void CloseSharedMemory( SHARED_CONTEXT *context )
{
	if ( context->pointer ) {
		UnmapViewOfFile( context->pointer);
		context->pointer = NULL;
	}
	if ( context->handle ) {
		CloseHandle( context->handle );
		context->handle = NULL;
	}
}

void *GetSharedAddress( SHARED_STRUCT *sharedPointer )
{
	return sharedPointer ? (LPVOID)( (LPBYTE)sharedPointer + offsetof( struct _SHARED_STRUCT, customStruct ) ) : NULL;
}
