#include "stdafx.h"
#include "common.h"

SIMPLE_OSVERSION	GetSimpleOSVersion( void )
{
	OSVERSIONINFOEX ver;
	static SIMPLE_OSVERSION soVer = OS_UNKNOWN;

	if ( soVer != OS_UNKNOWN ) return soVer;

	ver.dwOSVersionInfoSize = sizeof(ver);
	GetVersionEx( (LPOSVERSIONINFO)&ver );

	switch( ver.dwPlatformId )
	{
	case VER_PLATFORM_WIN32s:
		soVer = OS_OLD;
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		soVer = OS_9X;
		break;

	case VER_PLATFORM_WIN32_NT:
		switch( ver.dwMajorVersion )
		{
		case 3:
			soVer = OS_OLD;
			break;

		case 4:
			soVer = OS_NT4;
			break;

		case 5:
			switch( ver.dwMinorVersion )
			{
			case 0:
				soVer = OS_2000;
				break;

			case 1:
				soVer = OS_XP;
				break;

			case 2:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_XP;
					break;

				default:
					soVer = OS_S2003;
					break;
				}
				break;

			default:
				soVer = OS_NEWER;
				break;
			}
			break;

		case 6:
			switch( ver.dwMinorVersion )
			{
			case 0:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_VISTA;
					break;

				default:
					soVer = OS_S2008;
					break;
				}
				break;

			case 1:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_7;
					break;

				default:
					soVer = OS_S2008R2;
					break;
				}
				break;

			case 2:
				switch( ver.wProductType )
				{
				case VER_NT_WORKSTATION:
					soVer = OS_8;
					break;

				default:
					soVer = OS_S2012;
					break;
				}
				break;

			default:
				soVer = OS_NEWER;
				break;
			}
			break;

		default:
			soVer = OS_NEWER;
			break;
		}
		break;
	}

	return soVer;
}

void FillInputKeyboard( INPUT *input, WORD vK, BOOL bKeyUp, BOOL bScanCode, WORD scanCode )
{
	memset( input, 0, sizeof(INPUT) );
	input->type				= INPUT_KEYBOARD;
	input->ki.wVk			= vK;
	if ( GetSimpleOSVersion() >= OS_2000 ) {
		input->ki.wScan			= ( scanCode == 0xffff ) ? MapVirtualKey( vK, 0 ) : scanCode;
		input->ki.dwFlags		= ( bKeyUp ? KEYEVENTF_KEYUP : 0 ) | ( bScanCode ? KEYEVENTF_SCANCODE : 0 );
	}
	else {
		input->ki.wScan			= 0;
		input->ki.dwFlags		= ( bKeyUp ? KEYEVENTF_KEYUP : 0 );
	}
	input->ki.dwExtraInfo	= GetMessageExtraInfo();
}
