#include "StdAfx.h"
#include "ImeLoggerDlg.h"
#include "common.h"
#include "resource.h"
#include <windowsx.h>
#include "misc.h"
#include <time.h>

extern SETTINGS *shared;


ImeLoggerDlg::ImeLoggerDlg( UINT idResource )
	: Dialog( idResource )
{
}

ImeLoggerDlg::~ImeLoggerDlg(void)
{
}

INT_PTR CALLBACK ImeLoggerDlg::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	TCHAR name[_MAX_PATH];
	time_t t;
	struct tm tm;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		shared->hwndImeLogger = m_hDlg;
		return (INT_PTR)TRUE;
		break;

	case WM_FROMHOOK:
		GetProcessName( (DWORD)wParam, name, _countof(name) );
		time( &t );
		localtime_s( &tm, &t );
		LogOutput( _T("%02d:%02d:%02d : %d[%s] / %d\r\n"), tm.tm_hour, tm.tm_min, tm.tm_sec, wParam, name, lParam );
		break;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDOK:
		case IDCANCEL:
			shared->hwndImeLogger = NULL;
			EndDialog( m_hDlg, wmId );
			break;
		}
		break;
	}

	return (INT_PTR)FALSE;
}

void ImeLoggerDlg::LogOutput( TCHAR *format, ... )
{
	HWND hLogWnd;
	va_list args;
	int len, len2;
	TCHAR *buffer;

	hLogWnd = GetDlgItem( m_hDlg, IDC_EDIT_LOG );

	va_start( args, format );
	len = _vsctprintf( format, args ) + 1;

	buffer = new TCHAR[len];
	_vstprintf_s( buffer, len, format, args );

	len2 = GetWindowTextLength( hLogWnd );
	HWND hPrevFocused = ::SetFocus( hLogWnd );
	Edit_SetSel( hLogWnd, len2, len2 );
	Edit_ReplaceSel( hLogWnd, buffer );
	::SetFocus( hPrevFocused );

	delete[] buffer;
}
