#ifndef _MAIN_WINDOW_H_
#define _MAIN_WINDOW_H_

#include "Window.h"
#include "AboutDlg.h"
#include "DynamicApi.h"
#include "AppProfile.h"
#include "SyncRun.h"
#include "NotifyIcon.h"
#include "ImeLoggerDlg.h"

class MainWindow : public Window
{
public:
	MainWindow(void);
	~MainWindow(void);

protected:
	AboutDlg *m_aboutDlg;
	AppProfile prof;
	SyncRun sync;
	NotifyIcon notifyIcon;
	BOOL waitForMsgBox;
	ImeLoggerDlg *m_imeLoggerDlg;

	BOOL Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
	void Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
	void Cls_OnDestroy(HWND hwnd);
	BOOL Cls_OnTrayIconMessage( UINT mouseMsg, UINT iconId );
	void Cls_OnTaskbarCreated( void );
	void Cls_OnDllMessage( UINT type );
	void Cls_OnSharedStatus( WPARAM wParam, LPARAM lParam );

	void Init(void);
	INT_PTR CALLBACK WndProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	void AddBootcampIcon(void);
	static BOOL CALLBACK EnumBootcampProc(HWND hWnd, LPARAM lParam);
};

#endif//_MAIN_WINDOW_H_
