#include "stdafx.h"


INT_PTR CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_CREATE:
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		break;

	case WM_CLOSE:
		DestroyWindow( hWnd );
		break;

	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;
	}

	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}


extern "C" __declspec(dllexport) BOOL DummyWindow(void)
{
	BOOL bRet = FALSE;
	WNDCLASSEX wcex;
	HWND hWnd;
	MSG msg;
	HINSTANCE hInst;
	ATOM classAtom = 0;
	TCHAR dummyIdent[256];
	int retry = 10;

	do {
		hInst = GetModuleHandle(NULL);

		memset( &wcex, 0, sizeof(wcex) );
		wcex.cbSize			= sizeof(WNDCLASSEX);
		wcex.style			= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc	= (WNDPROC)WndProc;
		wcex.hInstance		= hInst;
		wcex.lpszClassName	= dummyIdent;
		wcex.hIconSm		= NULL;

		do {
			Sleep(1);
			_stprintf_s( dummyIdent, _countof(dummyIdent), _T("DeltaEnd Ejector Dummy Window Identifier : %d"), GetTickCount() );
		} while( !( classAtom = RegisterClassEx(&wcex) ) && ( retry-- > 0 ) );
		if ( !classAtom) break;

		hWnd = CreateWindow( dummyIdent,
							dummyIdent,
							WS_OVERLAPPEDWINDOW,
							10,
							10,
							10,
							10,
							NULL,
							NULL,
							hInst,
							NULL );

		if ( !hWnd ) break;

		while( GetMessage( &msg, NULL, 0, 0 ) )
		{
			DispatchMessage( &msg );
		}
		bRet = TRUE;

	} while( FALSE );

	if ( classAtom ) {
		UnregisterClass( dummyIdent, hInst );
	}

	return bRet;
}
